/*
  This program is made by Sven Sonneveld for the Smart Environment project
 This code recieves data from the arduino through a serial connection
 This data will be stored in an CSV file
 This program will auto-save the data every second\
 When you click the data will also be saved and the program will close
 This program was made on 19-1-2021
 */

//FileWriter
PrintWriter output;
int counter;

//Serial Connection
import processing.serial.*;
Serial port;

void setup() {
  //Choose where to write
  output=createWriter("DataBase9.csv"); //Change the database everyime while testing, because the previous one gets overwritten 
  //Serial communication
  port = new Serial(this, Serial.list()[2], 9600);
}

void draw() {
  //Read data with Serial + decoder
  while (port.available() > 0) {
    char recievedData=char(port.read());    
    if(recievedData=='A'){//remove A's from the recieved data
    print("A");
    }
    else if (recievedData=='B') {//remove B's from the recieved data and put in a ","
      output.print(",");
      print(" B");
    } 
    else {
      output.print(recievedData);//The actual data without the letters
      print(recievedData);
    }
  }

  //auto_save
  if (counter>=(frameRate*1)) {//timer; 1 is the amount of seconds between saves
    //output.flush();//save
    counter=0;
    //println("Saved");
  } else {
    counter++;
  }
}

//Check if mouse is pressed; if it is the program will save and close
void mousePressed() {
  output.flush(); // Writes the remaining data to the file
  output.close(); // Finishes the file
  exit(); // Stops the program
}
